(function () {
    'use strict';

    function onConfig($urlRouterProvider, RestangularProvider, localStorageServiceProvider, $ionicConfigProvider, SERVER_API_URL) {
        localStorageServiceProvider.setPrefix('indiquetrp');

        RestangularProvider.setBaseUrl(SERVER_API_URL);
        RestangularProvider.setRestangularFields({
            id: 'id'
        });
        //RestangularProvider.setDefaultHeaders({'CAAUTH': "Teste"});
        //RestangularProvider.setDefaultHttpFields({withCredentials: true});

        $ionicConfigProvider.navBar.alignTitle('left');
        $ionicConfigProvider.backButton.text('').previousTitleText(false);

        //$ionicConfigProvider.views.swipeBackEnabled(true);
        //$ionicConfigProvider.views.transition('ios');
        $ionicConfigProvider.navBar.positionPrimaryButtons('right');
        $ionicConfigProvider.scrolling.jsScrolling(false);
        $urlRouterProvider.otherwise('/signin');

    }

    function onRun(
        $ionicPlatform, $rootScope, $location, $ionicPopup, $ionicModal,
        Authentication, $http, $templateCache, $state, SERVER_API_URL,
        $cordovaStatusbar, $cordovaSplashscreen, $cordovaInAppBrowser, 
        $cordovaContacts, Restangular, $ionicLoading, $ionicPopover, $sce,
        localStorageService, $ionicBody
    ) {
        $ionicPlatform.ready(function() {
            if (window.StatusBar) {
                //StatusBar.styleBlackOpaque();
                $cordovaStatusbar.overlaysWebView(false); //red
                //$cordovaStatusbar.style(1);
                $cordovaStatusbar.styleHex('#ddac00');
            }
            $rootScope.me = Authentication.getCurrentUser();
            if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.disableScroll(true);
            $cordovaSplashscreen.hide();
        }

        $rootScope.loadIni();
        $rootScope.loadEstados();
        $rootScope.loadUnidades();
        $rootScope.loadProdutos();
        //$http.get('app/components/datepicker/datepicker-popup.html', { cache: $templateCache });

    });
    $rootScope.$on('$stateChangeStart', function (event, toState) {
        if(toState.data.authenticate && !Authentication.isAuthenticated()) {
            console.log('No authorized!');
            Authentication.signout();
            $state.go('signin')
            event.preventDefault();
        }
    });

    $rootScope.trustAsHtml = function(string) {
        return $sce.trustAsHtml(string);
    };

    $rootScope.loadEstados = function(){
        Restangular
        .one('estados.json')
        .customGET()
        .then(function(response) {
            console.log(response.data);
            $rootScope.todosEstados = response.data;
        }, function(){ return; });
    }

    $rootScope.loadIni = function(){
        
        $rootScope.iniData = localStorageService.get('iniData');
        //$rootScope.iniData1 = $sce.trustAsHtml($rootScope.iniData.bloco1.content);

        $rootScope.iniConfig = localStorageService.get('iniConfig');
        Restangular
        .one('ini.json')
        .customGET()
        .then(function(response) {
            console.log(response.empresas);
            localStorageService.set('iniData',response.blocks);
            localStorageService.set('iniConfig',response.configs);
            $rootScope.iniData = response.blocks;
            $rootScope.iniConfig = response.configs;
        }, function(){ return; });
    }

    $rootScope.loadUnidades = function(){
        $rootScope.todasUnidades = localStorageService.get('todasUnidades');
        Restangular
        .one('unidades.json')
        .customGET()
        .then(function(response) {
            console.log(response.empresas);
            localStorageService.set('todasUnidades',response.empresas);
            $rootScope.todasUnidades = response.empresas;
        }, function(){ return; });
    }

    $rootScope.loadProdutos = function(){
        $rootScope.todasUnidades = localStorageService.get('todasUnidades');
        Restangular
        .one('produtos.json')
        .customGET()
        .then(function(response) {
            console.log(response.products);
            localStorageService.set('tipoVeiculos',response.products);
            $rootScope.tipoVeiculos = response.products;
        }, function(){ return; });
    }

    $rootScope.logout = function() {
        $rootScope.exitPopup.hide();
        var confirmPopup = $ionicPopup.confirm({
            title: 'Sair',
            template: 'Você tem certeza que desejar sair?'
        });

        confirmPopup.then(function(res) {
            if(res) {
                console.log('You are sure');
                if (window.StatusBar) {
                    $cordovaStatusbar.overlaysWebView(false); //red
                    //$cordovaStatusbar.style(1);
                    //$cordovaStatusbar.styleHex('#0D1F33');
                }

                Authentication.signout();

                $state.go('signin');
            } else {
                console.log('You are not sure');
            }
        });
    };

    $rootScope.openRegulamento = function(){
        var options = {
            location: 'yes',
            clearcache: 'yes',
            toolbar: 'yes'
        };
        $cordovaInAppBrowser.open(SERVER_API_URL+'/regulamento.pdf', '_system', options)
        .then(function(event) {
            // success
        })
        .catch(function(event) {
            // error
        });
    }

    $rootScope.openUrl = function(url){
        var options = {
            location: 'yes',
            clearcache: 'yes',
            toolbar: 'yes'
        };
        $cordovaInAppBrowser.open(url, '_system', options)
        .then(function(event) {
            // success
        })
        .catch(function(event) {
            // error
        });
    }

    $ionicPopover.fromTemplateUrl('app/components/sidemenu/submenu.html', {
        scope: $rootScope,
    }).then(function(popover) {
        console.log('POPOVER!', popover);
        $rootScope.exitPopup = popover;
    });

    $ionicModal.fromTemplateUrl('app/routes/indicar/indicar.html', {
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $rootScope.modal = modal;
    });

    $ionicModal.fromTemplateUrl('app/routes/terms/terms.html', {
        id: 'terms',
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $rootScope.modalTerms = modal;
    });

    $ionicModal.fromTemplateUrl('app/routes/profile/profile.html', {
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $rootScope.modalProfile = modal;
    });

    $rootScope.$on('modal.shown', function(event, modal) {
        if(modal.id === 'terms'){
            $rootScope.pdfShow = true;
        }
    });

    $rootScope.pdfShow = false;

    $rootScope.sair = function($event) {
        console.log('sair!', $rootScope.exitPopup);
        $rootScope.exitPopup.show($event);

    };
    $rootScope.profile = function() {
        $rootScope.modalProfile.show();
    };
    $rootScope.fecharProfile = function() {
        $rootScope.modalProfile.hide();
        $ionicBody.removeClass('modal-open');
    };

    $rootScope.indicar = function() {
        $rootScope.modal.show();
    };
    $rootScope.fecharIndicar = function() {
        $rootScope.modal.hide();
    };

    $rootScope.terms = function() {
        $rootScope.modalTerms.show();
    };
    $rootScope.fecharTerms = function() {
        $rootScope.modalTerms.hide();
    };

    $rootScope.pdfUrl = SERVER_API_URL+'/regulamento.pdf';
    

    $rootScope.pickContact = function(){
        console.log('contatos');
        $rootScope.contact = false;
        $cordovaContacts.pickContact().then(function(contact) {
            console.log('contact', contact);
            if(contact.name !== undefined && contact.name.formatted !== undefined){
                $rootScope.indForm.name = contact.name.formatted;
            }
            if(contact.phoneNumbers !== undefined && contact.phoneNumbers !== null){
                if(contact.phoneNumbers[0] !== undefined){
                    $rootScope.indForm.phone = contact.phoneNumbers[0].value;
                }
                if(contact.phoneNumbers[1] !== undefined){
                    $rootScope.indForm.phone_alt = contact.phoneNumbers[1].value;
                }
            }
            if(contact.emails !== undefined && contact.emails !== null){
                if(contact.emails[0] !== undefined){
                    $rootScope.indForm.email = contact.emails[0].value;
                }
            }
            if(contact.organizations !== undefined && contact.organizations !== null){
                if(contact.organizations[0] !== undefined){
                    $rootScope.indForm.company = contact.organizations[0].name;
                }
            }
            $rootScope.contact = contact;
        }, function(error){
            console.log(error);
        });

    };

    $rootScope.indFormErros = false;
    $rootScope.indForm = {
        name: '',
        phone: '',
        phone_alt: '',
        company: '',
        city: '',
        email: '',
        state: '',
        product_id: '',
        observations: ''
    };
    $rootScope.indicacao = function(isValid, data){
        if(!isValid) {return;}
        $rootScope.indFormErros = false;
        $ionicLoading.show();
        Restangular
        .one('indicacao')
        .customPOST(data)
        .then(function(response) {
            $ionicLoading.hide();
            console.log(response.data);
            if(response.success){
                var successPopup = $ionicPopup.alert({
                    title: 'SUCESSO!',
                    template: response.data.msg
                });
                successPopup.then(function(res) {
                    $rootScope.indForm = {};
                });
            } else {
                var errorPopup = $ionicPopup.alert({
                    title: 'ERRO!',
                    template: 'Corrija os campos indicados e tente novamente!'
                });
                $rootScope.indFormErros = [];
                angular.forEach(response.data.erros, function(value, key){
                    angular.forEach(value, function(value2, key2){
                        $rootScope.indFormErros.push(value2);
                    });
                });
                errorPopup.then(function(res) {

                });
            }
        }, function(){
            $ionicLoading.hide();
        });


    }

}

angular
.module('app.core')
.config(onConfig)
.run(onRun)
//.constant('SERVER_API_URL', 'http://54.149.150.26/Indique'); //tmp online
.constant('SERVER_API_URL', 'http://54.149.150.26/homolog'); //tmp online
//.constant('SERVER_API_URL', 'http://localhost/trp-server/web'); //local - serve
//.constant('SERVER_API_URL', 'http://192.168.1.14/trp-server/web'); //local - serve
})();
