angular.module('app.directives', [])

.directive('a', function () {
    return {
        restrict: 'E',
        link: function (scope, element, attrs) {
            if ( !attrs.href ){
                return;
            }
            var externalRe = new RegExp("^(http|https)://");
            var url = attrs.href;

            if(externalRe.test(url)) {
                element.on('click',function(e){
                    e.preventDefault();
                    if(attrs.ngClick){
                        scope.$eval(attrs.ngClick);
                    }
                    window.open(encodeURI(url), '_system');
                });
            }
        }
    };
})

.directive('ionSlidex', [
    '$animate',
    '$timeout',
    function($animate, $timeout) {
        return {
            restrict: 'E',
            transclude: true,
            scope: {
                options: '=',
                slider: '='
            },
            template: '<div class="swiper-container">' +
            '<div class="swiper-wrapper" ng-transclude>' +
            '</div>' +
            '<div ng-hide="!showPager" class="swiper-pagination"></div>' +
            '</div>',
            controller: ['$scope', '$element', function($scope, $element) {
                var _this = this;

                this.update = function() {
                    $timeout(function() {
                        _this.__slider.update();
                        if (_this._options.loop) {
                            _this.__slider.createLoop();
                        }

                        // Don't allow pager to show with > 10 slides
                        if (_this.__slider.slides.length > 10) {
                            $scope.showPager = false;
                        }
                    });
                };

                this.rapidUpdate = ionic.debounce(function() {
                    _this.update();
                }, 50);

                this.getSlider = function() {
                    return _this.__slider;
                };
                var options = $scope.options || {};
                var newOptions = angular.extend({
                    pagination: $element.children().children()[1],
                    paginationClickable: true,
                    lazyLoading: true,
                    preloadImages: false
                }, options);

                this._options = newOptions;

                $timeout(function() {
                    var slider = new ionic.views.Swiper($element.children()[0], newOptions, $scope);

                    _this.__slider = slider;
                    $scope.slider = _this.__slider;

                    $scope.$on('$destroy', function() {
                        slider.destroy();
                    });
                });

            }],


            link: function($scope, $element) {
                $scope.showPager = true;
                // Disable ngAnimate for slidebox and its children
                $animate.enabled(false, $element);
            }
        };
    }])
    .directive('ionSlidexPage', [function() {
        return {
            restrict: 'E',
            require: '?^ionSlidex',
            transclude: true,
            replace: true,
            template: '<div class="swiper-slide" ng-transclude></div>',
            link: function($scope, $element, $attr, ionSlidesCtrl) {
                ionSlidesCtrl.rapidUpdate();
            }
        };
    }])




    .directive('fabScrollContainer', function () {
        return {
            restrict: 'A',
            controller: ['$element', function ($element) {
                $element.parent().data('fabScrollContainer', $element);
            }]
        };
    })
    .directive('ionFab', function fabButtonDirective() {
        return {
            restrict: 'E',
            replace: true,
            transclude: true,
            template: template,
            link: link
        };

        //isAnchor
        function isAnchor(attr) {
            return angular.isDefined(attr.href) || angular.isDefined(attr.ngHref) || angular.isDefined(attr.uiSref);
        }

        //template
        function template(element, attr) {
            return isAnchor(attr) ?
            '<a class="fab" ng-transclude></a>' :
            '<button class="fab" ng-transclude></button>';
        }

        //link
        function link(scope, element, attr) {
            var liveDisplace = (attr.liveDisplace && attr.liveDisplace != 'false') || (!attr.liveDisplace && !attr.animation);
            var targetEl = element.inheritedData('fabScrollContainer') || window;
            console.log(targetEl);
            element.addClass('animated');
            var scroll = 0, max = 80, current = 0, prevScroll = 0;
            targetEl.bind('scroll', function (e, scrollTop, scrollLeft) {
                scroll = (window.ionic && e.detail) ? e.detail.scrollTop : e.target.scrollTop;
                if (liveDisplace) {
                    current = scroll >= 0 ? Math.min(max, Math.max(0, current + scroll - prevScroll)) : 0;
                    window.requestAnimationFrame(function () {
                        element.css("transform", "translate3d(0, " + current + "px, 0)");
                    });
                }
                else {
                    if (current < scroll) {
                        current = scroll;
                        if (attr.animation == 'zoom')
                        element.removeClass('zoomIn').addClass('zoomOut');
                        else if (attr.animation == 'rotate')
                        element.removeClass('rotateIn').addClass('rotateOut');
                        else
                        element.removeClass('fadeInUp').addClass('fadeOutDown');
                    }
                    if (current > scroll) {
                        current = scroll;
                        if (attr.animation == 'zoom')
                        element.removeClass('zoomOut').addClass('zoomIn');
                        else if (attr.animation == 'rotate')
                        element.removeClass('rotateOut').addClass('rotateIn');
                        else
                        element.removeClass('fadeOutDown').addClass('fadeInUp');
                    }
                }
                prevScroll = scroll;
            });
        }
    });
