(function () {
    'use strict';

    angular.module('app.home')

    .controller('homeCtrl', function(
        $scope, $rootScope,  Restangular, $ionicPopup, $ionicScrollDelegate,
        $ionicPosition, $state, $ionicHistory, localStorageService, $cordovaStatusbar,
        $cordovaCamera, $cordovaFileTransfer, $ionicLoading, SERVER_API_URL
    ) {
        
        $scope.sliderDestaqueOptions = {
            "initialSlide": 0,
            "centeredSlides": true,
            "spaceBetween": 0,
            "slideToClickedSlide": true
        };
        $scope.sliderPlacarOptions = {
            "initialSlide": 1,
            "centeredSlides": true,
            "spaceBetween": 10,
            "slideToClickedSlide": true
        };
        $scope.isliked = function(pictureId){
            Restangular
            .all('isliked/'+pictureId+'/.json')
            .customGET("")
            .then(function(response) {
                console.log(response);
                $scope.liked = response.liked;
                $scope.data.fotos[0].likes = response.qtd;
            });
        };
        $scope.loadData = function(){
            $scope.data = localStorageService.get('dataHome');
            Restangular
            .all('index.json')
            .customGET("")
            .then(function(response) {
                response.year = '2016';
                console.log('home data', response)
                localStorageService.set('dataHome',response);
                $scope.data = response;
                //$scope.isliked($scope.data.fotos[0].id);

            });
        };
        $scope.loadData();
        $scope.liked = 0;

        $scope.like = function(pictureId){
            var likeAction = 'like';
            if($scope.liked){
                likeAction = 'dislike';
            }
            Restangular
            .all(likeAction+'/'+pictureId+'/.json')
            .customGET("")
            .then(function(response) {
                $scope.liked = response.liked;
                $scope.data.fotos[0].likes = response.qtd;
            });
        };

        $scope.changeYear = function(){
            console.log('change year', $scope.data.year);
        }

        $scope.jumpToScore = function () {
            var scorePos = $ionicPosition.position(angular.element(document.getElementById('placar-geral')));
            $ionicScrollDelegate.$getByHandle('myScroll').scrollTo(0, scorePos.top, true);
        }

        $scope.goGaleria = function () {
            $ionicHistory.nextViewOptions({
                disableBack: true
            });
            $state.go('app.galeria');
        }

        $scope.openFoto = function() {
            $scope.formDataFoto = {}
            var options = {
                quality: 65,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                allowEdit: false,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 800,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation: false
            };

            $cordovaCamera.getPicture(options).then(function(imageUrl) {
                console.log(imageUrl);
                $scope.uploadPercent = 0;
                var myPopup = $ionicPopup.show({
                    template: '<input type="title" autofocus ng-model="formDataFoto.title">',
                    title: 'Descrição',
                    subTitle: 'Insira uma descrição para a foto',
                    scope: $scope,
                    buttons: [
                        { text: 'Cancelar' },
                        {
                            text: '<b>Enviar</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                console.log(e);
                                if (!$scope.formDataFoto.title) {
                                    e.preventDefault();
                                } else {
                                    return $scope.formDataFoto.title;
                                }
                            }
                        }
                    ]
                });

                myPopup.then(function(res) {
                    console.log('Tapped!', res);
                    $ionicLoading.show({
                        template: 'Enviando... {{uploadPercent}}%',
                        scope: $scope,
                    });
                    $cordovaFileTransfer.upload(SERVER_API_URL+'/foto.json', imageUrl, {
                        fileKey: "picture",
                        params: {
                            title: res
                        },
                    })
                    .then(function(result) {
                        console.log('sucess!', result)
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Sucesso!',
                            template: 'A foto foi enviada com sucesso! Agora é só aguardar a aprovação pela nossa equipe.'
                        });
                    }, function(err) {
                        console.log('err!', err)
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Erro!',
                            template: 'Erro ao enviar a foto. Tente novamente!'
                        });
                    }, function (progress) {
                        console.log('progress!', progress)
                        $scope.uploadPercent = Math.round(progress.loaded / progress.total * 100);
                    });

                });

            }, function(err) {
                console.log(err);
            });
        }

    });

})();
