(function () {
    'use strict';

    angular.module('app.novidades')

    .controller('novidadeCtrl', function($scope, Restangular, $stateParams, $cordovaSocialSharing, SERVER_API_URL, $ionicLoading, localStorageService) {

        $scope.loadData = function(id){
            $scope.data = localStorageService.get('dataNovidades');
            Restangular
            .one('noticia/'+id+'.json').get()
            .then(function(response) {
                localStorageService.set('dataNovidades', response.data);
                $scope.data = response.data;
            });
        };
        if($stateParams.id){
            $scope.loadData($stateParams.id);
        } else {

        }

        $scope.share = function(noticia){
            $ionicLoading.show();
            var message = noticia.title;
            var subject = "Veja mais sobre essa novidade da Indique a TRP.";
            var file = noticia.picture_url;
            var link = SERVER_API_URL + '/noticia/' + noticia.id + '/' + noticia.slug;

            $cordovaSocialSharing
            .share(message, subject, file, link)
            .then(function(result) {
                // Success!
                $ionicLoading.hide();
            }, function(err) {
                // An error occured. Show a message to the user
                $ionicLoading.hide();
            });

        }
    });

})();
