(function () {
    'use strict';

    angular.module('app.pontos')

    .controller('pontosCtrl', function($scope, Restangular, $ionicPopup, $filter) {

        $scope.sliderPlacarOptions = {
            "initialSlide": 1,
            "centeredSlides": true,
            "spaceBetween": 10,
            "slideToClickedSlide": true
        };
        $scope.tabAtual = 2;
        $scope.setAba = function(qual){
            $scope.tabAtual = qual;
        };

        $scope.loadData = function(){
            Restangular
            .all('meus-pontos.json')
            .customGET("")
            .then(function(response) {
                console.log('MEUS PONTOS', response)
                var totalPoints = 0;
                angular.forEach(response.points, function(value, key){
                    totalPoints += value.value;
                });
                response.total = totalPoints + response.saldo;
                $scope.data = {
                    indicacoes: response.indicacoes,
                    points: response.points,
                    saldo: response.saldo,
                    total: response.total,
                    stats: response.stats,
                    months: response.months,
                    blocks: response.blocks,
                    selectedMonth: response.selectedMonth,
                };
            });
        };
        $scope.loadData();

        $scope.loadMonth = function(){
            var tmpData = $scope.data.selectedMonth.split("/");

            $scope.data.indicacoes = false;
            $scope.data.points = false;

            Restangular
            .all('meus-pontos/' + tmpData[0] + '/' + tmpData[1] + '.json')
            .customGET("")
            .then(function(response) {
                $scope.data.selectedMonth = response.selectedMonth;
                $scope.data.saldo = response.saldo;
                $scope.data.indicacoes = response.indicacoes;
                $scope.data.points = response.points;
                var totalPoints = 0;
                angular.forEach(response.points, function(value, key){
                    totalPoints += value.value;
                });
                $scope.data.total = totalPoints + response.saldo;
            });
        };

        $scope.openExtrato = function(data){
            console.log('extratoPopup data', data);
            var tpl = '';
            tpl += '<p><b>Data da Venda</b><br /> ' + $filter('date')(data.sale.created, 'dd/MM/yyyy HH:mm:ss') + '</p>';
            tpl += '<p><b>Indicação</b><br /> ' + data.sale.indication.name + ' (#' + data.sale.indication.id + ')</p>';
            tpl += '<p><b>Data da Indicação</b><br /> ' + $filter('date')(data.sale.indication.created, 'dd/MM/yyyy HH:mm:ss') + '</p>';

            tpl += '<p><b>Detalhes</b><br /> ';
            angular.forEach(data.sale.sales_products, function(value, k){
                console.log(value,k);
                //modal.find('.modal-pontos-produtos').append('<p> <strong>' + value.units + ' x ' + value.score + '</strong> (' + value.product.name + ') = <strong>' +  value.total + '</strong></p>');
                tpl +=  value.units + ' x ' + value.score + ' (' + value.product.name  + ') = ' + value.total + '<br />';
            });
            tpl += '</p>';

            tpl += '<p><b>Total Pontos</b><br /> ' + data.value + '</p>';
            var extratoPopup = $ionicPopup.alert({
                title: 'VENDA #'+data.sale.id,
                template: tpl
            });
            extratoPopup.then(function(res) {
                console.log('extratoPopup close');
            });
        };

        $scope.openIndicacao = function(data){
            console.log('indicacaoPopup data', data);
            var tpl = '';
            tpl += '<p><b>Indicação</b><br /> #' + data.id + '</p>';
            tpl += '<p><b>Nome Completo</b><br /> ' + data.name + '</p>';
            tpl += '<p><b>Telefone</b><br /> ' + data.phone + '</p>';
            if( data.phone_alt !== '' && data.phone_alt !== null ){
                tpl += '<p><b>Telefone alternativo</b><br /> ' + data.phone_alt + '</p>';
            }
            if( data.company !== '' && data.company !== null ){
                tpl += '<p><b>Empresa</b><br /> ' + data.company + '</p>';
            }
            tpl += '<p><b>E-mail</b><br /> ' + data.email + '</p>';
            tpl += '<p><b>Cidade</b><br /> ' + data.city + '</p>';
            tpl += '<p><b>Estado</b><br /> ' + data.state + '</p>';
            tpl += '<p><b>Data da Indicação</b><br /> ' + $filter('date')(data.created, 'dd/MM/yyyy HH:mm:ss') + '</p>';
            tpl += '<p><b>Situação</b><br /> ' + data.indication_situation.title + '</p>';
            if( data.observations !== '' && data.observations !== null ){
                tpl += '<p><b>Observações</b><br /> ' + data.observations + '</p>';
            }
            var indicacaoPopup = $ionicPopup.alert({
                title: 'INDICAÇÃO #'+data.id,
                template: tpl
            });
            indicacaoPopup.then(function(res) {
                console.log('indicacaoPopup close');
            });
        };

    });
})();
