/**
* Signup controller.
*
* @author    Martin Micunda {@link http://martinmicunda.com}
* @copyright Copyright (c) 2015, Martin Micunda
* @license   The MIT License {@link http://opensource.org/licenses/MIT}
*/
(function () {
    'use strict';

    /**
    * @ngdoc controller
    * @name SignupCtrl
    * @module app.signup
    * @requires $rootScope
    * @requires $state
    * @requires Authentication
    * @description
    * Controller for the signup page.
    *
    * @ngInject
    */
    function RecoveryCtrl($location, $scope, $state, Authentication, $ionicHistory, $ionicLoading, $cordovaDialogs) {
        $scope.goToSignin = function(){
            $ionicHistory.nextViewOptions({
                disableBack: true
            });
            $state.go('signin');
        };

        $scope.user = {email: ''};

        $scope.forgot = function(user){
            console.log('forgot', user);
            $ionicLoading.show();
            Authentication.recovery(user).then(function (response) {
                $ionicLoading.hide();
                if(response.success == 1){
                    $cordovaDialogs.alert(response.msg, 'E-mail enviado', 'OK');
                    $scope.user = {email: ''};
                } else {
                    $cordovaDialogs.alert(response.msg, 'Erro', 'OK');
                    //$scope.user = {email: ''};
                }
            }, function(error) {
                $ionicLoading.hide();
                $cordovaDialogs.alert('Erro enviando o e-mail.', 'Erro', 'OK');
                console.log('error ' + JSON.stringify(error));
            });
        };

    }

    angular
    .module('app.recovery')
    .controller('RecoveryCtrl', RecoveryCtrl);
})();
