/**
* Signup route.
*
* @author    Martin Micunda {@link http://martinmicunda.com}
* @copyright Copyright (c) 2015, Martin Micunda
* @license   The MIT License {@link http://opensource.org/licenses/MIT}
*/
(function () {
    'use strict';

    /**
    * @ngdoc object
    * @name signupRoute
    * @module app.signup
    * @requires $stateProvider
    * @description
    * Router for the signup page.
    *
    * @ngInject
    */
    function recoveryRoute($stateProvider) {
        $stateProvider
        .state('recovery', {
            url: '/recovery',
            templateUrl: 'app/routes/recovery/recovery.html',
            controller: 'RecoveryCtrl',
            data: {
                authenticate: false
            }
        });
    }

    angular
    .module('app.recovery')
    .config(recoveryRoute);

})();
